program Wandler;
uses crt,graph,vga,mausb;
const maxx:word=0;
      maxy:word=0;
      grafikan:boolean=false;
      graphdriver:integer=0;
      maxpunkte=100;
type Tcolor=array[0..15] of record r,g,b:byte; end;
     PSkizze=^TSkizze;
     Tskizze=record
               punkt:array[0..maxpunkte] of record
                 x,y:integer;
                 c:byte;
               end;
               maxpunkt,gesch:word;
               colors:TColor;
               weiter:pskizze;
             end;
var ani,aktani:pskizze;

  procedure grafikein;
  var graphmode,error:integer;
      pfad:string;
  begin
{    if (registerbgidriver(@EGAVGAdriver)<0) then
       writeln('Fehler beim Anmelden der Grafiktreiber!',^G);
       halt(1);
    end;}
    pfad:='c:\tp\bgi\';
    repeat
      graphdriver:=detect;
      detectgraph(graphdriver,graphmode);
      if graphdriver=graph.vga then begin
        graphdriver:=ega;
        graphmode:=egahi;
      end;
      if (graphdriver<>ega) then begin
        writeln('Ich gebe Dir einen Tip:');
        writeln('Kauf Dir ''ne VGA Karte !');
        readln;
        halt(1);
      end;
      initgraph(graphdriver,graphmode,pfad);
      error:=graphresult;
      if error<>0 then begin
        writeln(grapherrormsg(error));
        write(^G,'Geben Sie Ihren Grafik Pfad ein : ');
        readln(pfad);
        if pfad='' then halt(1);
      end;
    until error=0;
    grafikan:=true;
    maxx:=getmaxx;
    maxy:=getmaxy;
    setbkcolor(lightgray);
    overscan(lightgray);
    setfillstyle(solidfill,0);
  end;

  procedure error(s:string);
  begin
    if grafikan then closegraph;
    if s<>'' then writeln(s,^g);
    halt(1);
  end;

  procedure newpoint(x,y:word);
  begin
    with aktani^ do begin
      punkt[maxpunkt].x:=x;
      punkt[maxpunkt].y:=y;
      punkt[maxpunkt].c:=10;
      if (maxpunkt<>0) and ((x<>0) or (y<>0)) and
         ((punkt[pred(maxpunkt)].x<>0) or (punkt[pred(maxpunkt)].y<>0))
      then begin
        mausunsicht;
        line(punkt[pred(maxpunkt)].x,punkt[pred(maxpunkt)].y,x,y);
        maussicht;
      end;
      inc(maxpunkt);
    end;
    repeat until not mauskeypressed;
    
  end;

  procedure macheanimation;
  var tasten,xpos,ypos,altx,alty,letztx,letzty:word;
      vorh:boolean;
      gesetzt:boolean;

    procedure newskizze;
    begin
      mausunsicht;
      cleardevice;
      maussicht;
      if maxavail>sizeof(aktani^.weiter) then new(aktani^.weiter) else
        error('Zu wenig Speicher');
      aktani:=aktani^.weiter;
      aktani^.weiter:=nil;
      aktani^.gesch:=16;
      aktani^.maxpunkt:=0;
      gesetzt:=false;
    end;

    procedure ausgleich;
    var maxpunkte,n:word;
    begin
      aktani:=ani;
      maxpunkte:=0;
      while aktani<>nil do begin
        if aktani^.maxpunkt>maxpunkte then maxpunkte:=aktani^.maxpunkt;
        aktani:=aktani^.weiter;
      end;
      aktani:=ani;
      while aktani<>nil do with aktani^ do begin
        if maxpunkt<>maxpunkte then begin
          for n:=maxpunkt to pred(maxpunkte) do punkt[n]:=punkt[pred(maxpunkt)];
          maxpunkt:=maxpunkte;
        end;
        aktani:=aktani^.weiter;
      end;
    end;

  begin
    mausinit(vorh,tasten);
    if not vorh then error('Keine Maus gefunden');
    maussicht;
    altx:=maxx div 2;
    alty:=maxy div 2;
    xpos:=altx;
    ypos:=alty;
    letztx:=altx;
    letzty:=alty;
    mausminmaxx(0,maxx);
    mausminmaxy(0,maxy);
    mausgrafikcursor(0,16,pinsel);
    maussetpos(maxx div 2,maxy div 2);
    maussicht;
    setwritemode(xorput);
    gesetzt:=false;
    repeat
      repeat
        repeat
          maustastpos(tasten,xpos,ypos);
        until (xpos<>altx) or (ypos<>alty) or keypressed or (tasten<>0);
        if gesetzt then begin
          mausunsicht;
          line(letztx,letzty,altx,alty);
          line(letztx,letzty,xpos,ypos);
          maussicht;
          altx:=xpos;
          alty:=ypos;
        end;
      until keypressed or (tasten<>0);
      if (tasten<>2) and ((xpos<>letztx) or (ypos<>letzty)) then begin
        mausunsicht;
        line(letztx,letzty,xpos,ypos);
        maussicht;
        newpoint(xpos,ypos);
        letztx:=xpos;letzty:=ypos;
        gesetzt:=true;
      end else if (tasten=2) and (aktani^.maxpunkt>0) then newskizze;
    until keypressed;
    while keypressed do readkey;
    ausgleich;
    mausunsicht;
  end;

  procedure init;
  begin
    new(ani);
    ani^.weiter:=nil;
    ani^.gesch:=16;
    ani^.maxpunkt:=0;
    aktani:=ani;
    {farbinit fehlt}
  end;

  procedure animation;
  var z,n:word;
      seite:byte;
  begin
    seite:=0;
    cleardevice;
    setcolor(yellow);write(^G);
    setwritemode(normalput);
    repeat
      aktani:=ani;
      while (not keypressed) and (aktani<>nil) do
       with aktani^ do begin
        z:=0;
        repeat
          seite:=byte(not boolean(seite));
          setactivepage(seite);
          setvisualpage(byte(not boolean(seite)));
          waitsync;
          cleardevice;
          inc(z,gesch);
          if aktani^.weiter<>nil then for n:=0 to maxpunkt-2 do
            line(aktani^.punkt[n].x+longint(-aktani^.punkt[n].x+aktani^.weiter^.punkt[n].x)*z div 1024,
                 aktani^.punkt[n].y+longint(-aktani^.punkt[n].y+aktani^.weiter^.punkt[n].y)*z div 1024,
                 aktani^.punkt[succ(n)].x+longint(-aktani^.punkt[succ(n)].x+aktani^.weiter^.punkt[succ(n)].x)*z div 1024,
                 aktani^.punkt[succ(n)].y+longint(-aktani^.punkt[succ(n)].y+aktani^.weiter^.punkt[succ(n)].y)*z div 1024)
           else for n:=0 to maxpunkt-2 do
            line(aktani^.punkt[n].x+longint(-aktani^.punkt[n].x+ani^.punkt[n].x)*z div 1024,
                 aktani^.punkt[n].y+longint(-aktani^.punkt[n].y+ani^.punkt[n].y)*z div 1024,
                 aktani^.punkt[succ(n)].x+longint(-aktani^.punkt[succ(n)].x+ani^.punkt[succ(n)].x)*z div 1024,
                 aktani^.punkt[succ(n)].y+longint(-aktani^.punkt[succ(n)].y+ani^.punkt[succ(n)].y)*z div 1024);
        until z>=1024;
        aktani:=aktani^.weiter;
      end;
    until keypressed;
  end;

  procedure sichereanimation;
  var namE:string;
      f:text;
      n:word;
  begin
    textbackground(blue);
    textcolor(yellow);
    write('Gebe den Namen der Animation (ohne Erweiterung) ein : ');
    textcolor(lightmagenta);
    readln(name);
    if name='' then exit;
    assign(f,name+'.ANI');
    rewrite(f);
    aktani:=ani;
    while aktani<>nil do with aktani^ do begin
      writeln(f,maxpunkt);
      writeln(f,gesch);
      for n:=0 to 15 do writeln(f,colors[n].r,' ',colors[n].g,' ',colors[n].b);
      for n:=0 to pred(maxpunkt) do writeln(f,punkt[n].x,' ',punkt[n].y,' ',punkt[n].c);
      aktani:=aktani^.weiter;
    end;
    close(f);
  end;

  procedure ladeanimation(name:string);
  var f:text;
      n:word;
  begin
    assign(f,name+'.ANI');
    reset(f);
    while not eof(f) do begin
      with aktani^ do begin
        readln(f,maxpunkt);
        readln(f,gesch);
        for n:=0 to 15 do readln(f,colors[n].r,colors[n].g,colors[n].b);
        for n:=0 to pred(maxpunkt) do readln(f,punkt[n].x,punkt[n].y,punkt[n].c);
      end;
      if not eof(f) then begin
        if maxavail>sizeof(aktani^.weiter) then new(aktani^.weiter) else
          error('Zu wenig Speicher');
        aktani:=aktani^.weiter;
        aktani^.weiter:=nil;
      end;
    end;
    close(f);
  end;

begin
  grafikein;
  init;
  if paramcount=0 then begin
    macheanimation;
  end else ladeanimation(paramstr(1));
  if ani^.weiter<>nil then animation;
  closegraph;
  sichereanimation;
end.